<template>
  <div id="chart">
    <apexchart
      type="line"
      height="350"
      :options="chartOptions"
      :series="series"
    ></apexchart>
    <button @click.prevent="toggleColor">Click me</button>
    <button @click="toggleHide">Show / Hide</button>
    <button @click="toggleMove">Move</button>
  </div>
</template>

<script>
import { ref } from "vue";
export default {
  setup() {
    // const color = ref("#B3F7CA");

    function toggleColor() {
      const currentColor = chartOptions.value.annotations.xaxis[0].fillColor;
      let newColor = "";

      if (currentColor == "#F70000") newColor = "#B3F7CA";
      else newColor = "#F70000";

      chartOptions.value = {
        ...chartOptions.value,
        ...{
          annotations: {
            xaxis: [
              {
                x: new Date("3 Jan 2020").getTime(),
                x2: new Date("6 Jan 2020").getTime(),
                fillColor: newColor,
                opacity: 0.4,
                label: {
                  borderColor: newColor,
                  style: {
                    fontSize: "10px",
                    color: "#fff",
                    background: "#00E396",
                  },
                  offsetY: -10,
                  text: "X-axis range",
                },
              },
            ],
          },
        },
      };
      console.log("Toggle ", chartOptions.value);
      // chartja.value.updateSeries([
      //   {
      //     options: {
      //       xaxis: {
      //         x: new Date("3 Jan 2020").getTime(),
      //         x2: new Date("6 Jan 2020").getTime(),
      //         fillColor: color.value,
      //         opacity: 0.4,
      //         label: {
      //           borderColor: color.value,
      //           style: {
      //             fontSize: "10px",
      //             color: "#fff",
      //             background: "#00E396"
      //           },
      //           offsetY: -10,
      //           text: "X-axis range"
      //         }
      //       }
      //     }
      //   }
      // ]);
    }

    function toggleHide() {
      if (chartOptions.value.annotations.xaxis.length > 0) {
        chartOptions.value = {
          ...chartOptions.value,
          ...{
            annotations: {
              xaxis: [],
            },
          },
        };
      } else {
        chartOptions.value = {
          ...chartOptions.value,
          ...{
            annotations: {
              xaxis: [
                {
                  x: new Date("3 Jan 2020").getTime(),
                  x2: new Date("6 Jan 2020").getTime(),
                  fillColor: "#B3F7CA",
                  opacity: 0.4,
                  label: {
                    borderColor: "#B3F7CA",
                    style: {
                      fontSize: "10px",
                      color: "#fff",
                      background: "#00E396",
                    },
                    offsetY: -10,
                    text: "X-axis range",
                  },
                },
              ],
            },
          },
        };
      }
    }

    function toggleMove() {
      if (chartOptions.value.annotations.xaxis[0].x == 1577984400000) {
        chartOptions.value = {
          ...chartOptions.value,
          ...{
            annotations: {
              xaxis: [
                {
                  x: new Date("4 Jan 2020").getTime(),
                  x2: new Date("7 Jan 2020").getTime(),
                  fillColor: "#B3F7CA",
                  opacity: 0.4,
                  label: {
                    borderColor: "#B3F7CA",
                    style: {
                      fontSize: "10px",
                      color: "#fff",
                      background: "#00E396",
                    },
                    offsetY: -10,
                    text: "X-axis range",
                  },
                },
              ],
            },
          },
        };
      } else {
        chartOptions.value = {
          ...chartOptions.value,
          ...{
            annotations: {
              xaxis: [
                {
                  x: new Date("3 Jan 2020").getTime(),
                  x2: new Date("6 Jan 2020").getTime(),
                  fillColor: "#B3F7CA",
                  opacity: 0.4,
                  label: {
                    borderColor: "#B3F7CA",
                    style: {
                      fontSize: "10px",
                      color: "#fff",
                      background: "#00E396",
                    },
                    offsetY: -10,
                    text: "X-axis range",
                  },
                },
              ],
            },
          },
        };
      }
    }

    const monthData = {
      prices: [3.4, 4.3, 5.4, 3.66, 4.32, 5.23, 4.7],
      dates: [
        "2020-01-01",
        "2020-01-02",
        "2020-01-03",
        "2020-01-04",
        "2020-01-05",
        "2020-01-06",
        "2020-01-07",
      ],
    };
    const series = [
      {
        data: monthData.prices,
      },
    ];

    const chartOptions = ref({});
    chartOptions.value = {
      chart: {
        height: 350,
        type: "line",
        // id: "areachart-2",
        zoom: {
          enabled: false,
        },
        // animations: {
        //   enabled: true,
        //   easing: "linear",
        //   dynamicAnimation: {
        //     speed: 1000
        //   }
        // }
      },
      annotations: {
        xaxis: [
          {
            x: new Date("2020-01-03").getTime(),
            x2: new Date("2020-01-06").getTime(),
            fillColor: "#B3F7CA",
            opacity: 0.4,
            label: {
              borderColor: "#B3F7CA",
              style: {
                fontSize: "10px",
                color: "#fff",
                background: "#00E396",
              },
              offsetY: -10,
              text: "X-axis range",
            },
          },
        ],
      },
      dataLabels: {
        enabled: false,
      },
      stroke: {
        curve: "straight",
      },
      grid: {
        padding: {
          right: 30,
          left: 20,
        },
      },
      title: {
        text: "Line with Annotations",
        align: "left",
      },
      labels: monthData.dates,
      xaxis: {
        type: "datetime",
      },
    };
    return {
      series,
      chartOptions,
      toggleColor,
      toggleHide,
      toggleMove,
    };
  },
};
</script>
